#include <stdio.h>
#include <math.h>
/*#include <curses.h>*/
#include "graph.h"
#include "bubba.h"
#include "anneal.h"

#define NEWPAGE 12

static double T;
static int iter=0,downhill=0,accepted=0,tried=0,try=0;

extern int Random(int,int);
extern double NormRand();
extern void InitRand();

void a_output();

unsigned int
a_iter_value()
{
    fprintf(stderr,"a_iter_value=%d\n",iter);
    return(iter);
}


int /* bool */
a_choosepmove(part,type,m)
  struct partition *part;
  int type; 
  struct pmove *m;
{
  int setdex1=0,memdex1=0;
  int setdex2=0,memdex2=0;

  switch (type) {
    case MV1: 
      setdex1 = part->setmap[Random(0,part->numvalid-1)];
      memdex1 = Random(0,part->numinset[setdex1]-1);

      do {
        setdex2 = part->setmap[Random(0,part->numvalid-1)];
      } while (setdex1 == setdex2);

      memdex2 = Random(0,part->numinset[setdex2]-1);

      break;

    case MV2:
      do {
        setdex1 = part->setmap[Random(0,part->numvalid-1)];
        memdex1 = Random(0,part->numinset[setdex1]-1);

        do {
          setdex2=part->setmap[Random(0,part->numvalid-1)];
        } while (setdex1 == setdex2);

        memdex2 = part->numinset[setdex2];
      } while ((part->numinset[setdex1] >= part->numinset[setdex2]) && 
               (NormRand() > .33));

      break;

    case MV3:
     /* Check to make sure a MV3 is possible */
      if (part->numvalid == part->numsets) return(FALSE);

      do {
        setdex1 = part->setmap[Random(0,part->numvalid-1)];
      } while(part->numinset[setdex1] <= 1);

      memdex1 = Random(0,part->numinset[setdex1]-1);

      setdex2 = 0;
      while (part->numinset[setdex2] > 0) {
        setdex2++;
        if (setdex2 > part->numsets) {
          printf("CHOOSEPMOVE: setdex2 > numsets\n");
          exit(1);
	}
      }
      memdex2 = 0;

      break;

    default: 
      printf("Unknown pmove type (%d)\n",type);
      exit(1);
      
    }

  m->type = type;
  m->setdex1 = setdex1;
  m->memdex1 = memdex1;
  m->setdex2 = setdex2;
  m->memdex2 = memdex2;

  return(TRUE);
}


void
a_dopmove(part,m)
  struct partition *part;
  struct pmove *m;
{
  int temp;
  int *ptr1,*ptr2;
  int val1;

  switch (m->type) {
    case MV1:  
      ptr1 = &part->set[m->setdex1][m->memdex1];
      ptr2 = &part->set[m->setdex2][m->memdex2];
      temp = *ptr1;
      *ptr1 = *ptr2;
      *ptr2 = temp;
      break;
    case MV2:
      val1 = p_delmem(part,m->setdex1,m->memdex1);
      ptr2 = &part->set[m->setdex2][m->memdex2];
      *ptr2 = val1;
      part->numinset[m->setdex2]++;
      if (part->numinset[m->setdex1] == 0) {
	part->numvalid--;
        p_redosetmap(part);
      }
      break;
    case MV3:
      val1 = p_delmem(part,m->setdex1,m->memdex1);
      ptr2 = &part->set[m->setdex2][m->memdex2];
      *ptr2 = val1;
      part->numinset[m->setdex2]++;
      part->numvalid++;
      p_redosetmap(part);
      break;
    default:
      printf("DOPMOVE: Bogus type (%d)\n",m->type);
    }

  return;
}


void
a_reversepmove(part,m)
  struct partition *part;
  struct pmove *m;
{
  int temp;
  int *ptr1,*ptr2;

  switch (m->type) {
    case MV1:  
      ptr1 = &part->set[m->setdex1][m->memdex1];
      ptr2 = &part->set[m->setdex2][m->memdex2];
      temp = *ptr1;
      *ptr1 = *ptr2;
      *ptr2 = temp;
      break;
    case MV2:
      ptr1 = &part->set[m->setdex1][part->numinset[m->setdex1]];
      ptr2 = &part->set[m->setdex2][m->memdex2];
      *ptr1 = *ptr2;
      part->numinset[m->setdex1]++;
      part->numinset[m->setdex2]--;
      if (part->numinset[m->setdex1] == 1) {
	part->numvalid++;
        p_redosetmap(part);
        p_makeMG(part);
      }
      break;
    case MV3:
      ptr1 = &part->set[m->setdex1][part->numinset[m->setdex1]];
      ptr2 = &part->set[m->setdex2][m->memdex2];
      *ptr1 = *ptr2;
      part->numinset[m->setdex1]++;
      part->numinset[m->setdex2]--;
      part->numvalid--;
      p_redosetmap(part);
      p_makeMG(part);
      break;
    default:
      printf("DOPMOVE: Bogus type (%d)\n",m->type);
    }

  return;
}


int
a_pickapmove(width)
  int width;
{
  int type;
  double rnd;
  double m1p;
 
  /* Choose a pmove type */
  rnd = NormRand();

#ifdef DEBUG
  printf("Random Number: %g\n",rnd);
  printf("M1PROB: %g\n",M1_PROB((double) width));
  printf("M2PROB: %g\n",M2_PROB((double) width));
  printf("M3PROB: %g\n",M3_PROB((double) width));
#endif

  if (rnd < (m1p = M1_PROB((double) width))) {
    type = MV1;
  }
  else {
    if (rnd < (m1p + M2_PROB((double) width))) {
      type = MV2;
    }
    else type = MV3;
  }

  return(type);
}


void
a_neighbor(chan,part,retpmove)
  struct channel *chan;
  struct partition *part;
  struct pmove *retpmove;
{
  int valid = FALSE;
  int type;
  struct pmove thispmove;

  type = a_pickapmove(part->numvalid);

  while (! valid) { 
   /* Choose a pmove */
    if (! a_choosepmove(part,type,&thispmove)) {
      type = a_pickapmove(part->numvalid);
      continue;
    }

   /* Do the pmove */
    a_dopmove(part,&thispmove);
 
#ifdef DEBUG
    a_printpmove(thispmove); 
#endif

   /* If not valid then reverse the pmove */
    if ((valid = p_isvalid(chan,part,&thispmove)) == FALSE) {
#ifdef DEBUG
      printf("Pmove rejected!\n"); 
#endif
      a_reversepmove(part,&thispmove);
    }
  }

#ifdef DEBUG
  p_printpart(part); 
#endif

  retpmove->type = thispmove.type;
  retpmove->setdex1 = thispmove.setdex1;
  retpmove->setdex2 = thispmove.setdex2;
  retpmove->memdex1 = thispmove.memdex1;
  retpmove->memdex2 = thispmove.memdex2;

  return;
}


int /* bool */
a_accept(delta,Temp)
  double delta;
  double Temp;
{
  double prob,rnd;


  prob = MIN((1.0),(exp((-1.0*((double) delta))/(Temp))));

  rnd = NormRand();

#ifdef DEBUG
  printf("-1*delta/(BOLTZ*Temp) == %g\n",((-1.0*((double) delta))/(Temp)));
  printf("exp == %g\n",(exp((-1.0*((double) delta))/(Temp))));
  printf("Prob: %g\n",prob);
  printf("Rnd: %g\n",rnd);
#endif

  if (rnd <= prob) {
    return(TRUE);
  }

  return(FALSE);
}


double
a_cost(chan,part)
  struct channel *chan;
  struct partition *part;
{
  double term1,term2,term3;
  double cost,ret;
  int p,v,i,j,setdex;
  double U=0.0,u;

  term1 = ((double) part->numvalid) * ((double) part->numvalid);
  p = g_longest(part->MG);

  term2 = LAMBDA_P * ((double) p) * ((double) p);

 /* Calculate U */
  for (i=0; i<part->numvalid; i++) {
    setdex = part->setmap[i];
    for (v=0,j=0; j<part->numinset[setdex]; j++) {
      v += chan->snet[part->set[setdex][j]].length;
    }
    u = 1.0 - (((double) v) / chan->length);
    u = u * u;
    U += u;
  }

  term3 = LAMBDA_U * U;

  cost = term1 + term2 + term3;

  ret = cost - part->cost;

#ifdef DEBUG
  printf("term1: %g term2: %g term3: %g\n",term1,term2,term3);
  printf("A_COST: Returning: %g\n",ret);
#endif

  return(ret);
}


void
a_anneal(chan,part)
  struct channel *chan;
  struct partition *part;
{
  double T0,r;
  double N;
  int BestW;
  double delta;
  struct pmove pmove;

  T0 = (LAMBDA_T * (double) part->numvalid);
  T = T0;
  N = (LAMBDA_N * ((double) part->numsets * (double) part->numsets));

 /* Output initial solution */
  a_output(chan,part);

  while ((chan->minwidth < part->numvalid) && (T > LOWTEMP)) {
    tried = 0; accepted = 0; downhill = 0;
    BestW = BIGINT;
    
    while (((double) tried < (2.0 * N)) && ((double) downhill < N) && (chan->minwidth < part->numvalid)) {
     /* Find neighbor */
      a_neighbor(chan,part,&pmove);

     /* Compute cost change */
      delta = a_cost(chan,part);

     /* Accept or reject */
      if (a_accept(delta,T) == TRUE) {
        accepted++;
        part->cost += delta;
        if (part->numvalid < BestP->numvalid) {
          p_copy(BestP,part);
	}
        if (part->numvalid < BestW) {
          BestW = part->numvalid;
	}
        if (delta > 0) {
          downhill++;
	}
      }
      else {
        a_reversepmove(part,&pmove);
      }

#ifdef OUTPUT
      a_output(chan,part); 
#endif

      tried++;
      iter++;
    }

    printf("try=%4d, tried=%4d, accepted=%4d, iter=%6d\n",
        ++try, tried, accepted, iter);

    if (chan->minwidth >= part->numvalid) {
      break;
    }

   /* check for termination */
    if (((double) accepted / (double) tried) < 0.05) {
      printf("\nANNEAL:  Fewer than 5 percent of the pmoves were accepted\n");
      break;
    }

   /* update temperature */
    r = .8 + (.3/((double) ((BestW - chan->minwidth) + 1)));
    T = T * r;
  }

 /* In case the default soln is optimal */
  if (part->numvalid < BestP->numvalid) {
    p_copy(BestP,part);
  }

  a_output(chan,BestP);
  return;
}           


void
a_subnetprint(chan)
  struct channel *chan;
{
  int i;
  struct subnet *this;

  printf("--------------------\n");
  for (i = 0; i<chan->numsnets; i++) {
    this = &chan->snet[i];
    printf("%d: (%d) %d...%d\n",i,this->parent,this->left,this->right);
  }
  printf("--------------------\n");

  return;
}


void
a_printpmove(pmove)
  struct pmove pmove;
{
  printf("PMOVE: type=%d, from=(%d,%d) to=(%d,%d)\n",
         pmove.type,pmove.setdex1,pmove.memdex1,pmove.setdex2,pmove.memdex2);

  return;
}


void
a_output(chan,part)
 struct channel *chan;
 struct partition *part;
{
#ifdef CURSES
  move(0,0);
  printw("Iter:%4d  Temp:%4.4f\n",iter,T);
  printw("For This Temp -- tried:%4d  accepted:%4d  downhill:%4d\n",tried,accepted,downhill);
  printw("Width: %3d  Optimal: %3d\n",part->numvalid,chan->minwidth);
  printw("Cost: %4.4f\n",part->cost);
#endif

#ifndef CURSES
  putchar(NEWPAGE);
  printf("Iter:%4d  Temp:%4.4f\n",iter,T);
  printf("For This Temp -- tried:%4d  accepted:%4d  downhill:%4d\n",tried,accepted,downhill);
  printf("Width: %3d  Optimal: %3d\n",part->numvalid,chan->minwidth);
  printf("Cost: %4.4f\n",part->cost);
#endif

  c_makeruns(chan,part);
  o_outchan(chan);

#ifdef CURSES
  clrtobot();
  refresh();
#endif

  c_clearruns(chan);
  return;
}
