#define SPACING ""
#define DASHES  ""

#include <stdio.h>
/* #include <sys/time.h> */
#include <signal.h>
/* #include <curses.h> */

#include "graph.h"
#include "bubba.h"

#ifdef CURSES
o_outchan(chan)
 struct channel *chan;
{
 int i, j, width, length;
 char dummy[64];
 struct track *htrack, *vtrack;

  width = chan->width;
  length = chan->length;

 /* Top pins and terminals */
  for (i = 0; i < length; i++) {
    printw(SPACING);
    printw("%2d", chan->toppins[i]);
  }
  addch('\n');

  for (i = 0; i < length; i++) {
    printw(SPACING);
    printw(" %c", (chan->toppins[i] == 0) ? ' ' : '*');
  }
  addch('\n');

 /* Channel Rows */
  for (j = 1; j < width - 1; j++) {
    if (chan->htracks[j].numruns == 0) continue;
    htrack = &chan->htracks[j];

   /* Spacer row */

#ifdef VSPACE
    for (i = 0; i < length; i++) {
      printw(SPACING);
      printw(" ");
      vtrack = &chan->vtracks[i];
      if (o_inrun(vtrack,j)) {
        addch('|');
      }
      else addch(' ');
    }
    addch('\n');
#endif

   /* Real Row */
    for (i = 0; i < length; i++) {
      vtrack = &chan->vtracks[i];
      if ((i == 0) || (! o_inrun(htrack,i))) {
        printw(SPACING);
        printw(" ");
      }
      else {
        printw(DASHES);
        printw("-");
      }
      if (o_via(htrack,i) || o_via(vtrack,j)) {
        addch('+');
      }
      else if (o_inrun(vtrack,j)) {
        addch('|');
      }
      else if (o_inrun(htrack,i)) {
        addch('-');
      }
      else addch(' ');
    }
    addch('\n');
  }

 /* Bottom terminals and pins */

#ifdef VSPACE 
  for (i = 0; i < length; i++) {
    vtrack = &chan->vtracks[i];
    printw(SPACING);
    printw(" %c", (o_inrun(vtrack,j)) ? '|' : ' '); 
  }
  addch('\n');
#endif

  for (i = 0; i < length; i++) {
    printw(SPACING);
    printw(" %c", (chan->botpins[i] == 0) ? ' ' : '*');
  }
  addch('\n');

  for (i = 0; i < length; i++) {
    printw(SPACING);
    printw("%2d", chan->botpins[i]);
  }
  addch('\n');

  return(1);
}
#endif

#ifndef CURSES
o_outchan(chan)
 struct channel *chan;
{
 int i, j, width, length;
 char dummy[64];
 struct track *htrack, *vtrack;

  width = chan->width;
  length = chan->length;

 /* Top pins and terminals */
  for (i = 0; i < length; i++) {
    printf(SPACING);
    printf("%2d", chan->toppins[i]);
  }
  putchar('\n');

  for (i = 0; i < length; i++) {
    printf(SPACING);
    printf(" %c", (chan->toppins[i] == 0) ? ' ' : '*');
  }
  putchar('\n');

 /* Channel Rows */
  for (j = 1; j < width - 1; j++) {
    if (chan->htracks[j].numruns == 0) continue;
    htrack = &chan->htracks[j];

   /* Spacer row */

#ifdef VSPACE
    for (i = 0; i < length; i++) {
      printf(SPACING);
      printf(" ");
      vtrack = &chan->vtracks[i];
      if (o_inrun(vtrack,j)) {
        putchar('|');
      }
      else putchar(' ');
    }
    putchar('\n');
#endif

   /* Real Row */
    for (i = 0; i < length; i++) {
      vtrack = &chan->vtracks[i];
      if ((i == 0) || (! o_inrun(htrack,i))) {
        printf(SPACING);
        printf(" ");
      }
      else {
        printf(DASHES);
        printf("-");
      }
      if (o_via(htrack,i) || o_via(vtrack,j)) {
        putchar('+');
      }
      else if (o_inrun(vtrack,j)) {
        putchar('|');
      }
      else if (o_inrun(htrack,i)) {
        putchar('-');
      }
      else putchar(' ');
    }
    putchar('\n');
  }

 /* Bottom terminals and pins */

#ifdef VSPACE
  for (i = 0; i < length; i++) {
    vtrack = &chan->vtracks[i];
    printf(SPACING);
    printf(" %c", (o_inrun(vtrack,j)) ? '|' : ' '); 
  } 
  putchar('\n');
#endif

  for (i = 0; i < length; i++) {
    printf(SPACING);
    printf(" %c", (chan->botpins[i] == 0) ? ' ' : '*');
  }
  putchar('\n');

  for (i = 0; i < length; i++) {
    printf(SPACING);
    printf("%2d", chan->botpins[i]);
  }
  putchar('\n');

  return(1);
}
#endif

o_inrun(track,pos)
 struct track *track;
 int pos;
 {
 int i;
 struct run *thisrun;

  for (i = 0; i < track->numruns; i++) {
    thisrun = &track->runs[i];
    if ((pos > thisrun->start) && (pos <= thisrun->stop))
      return(1);
  }

  return(0);
}

o_via(track,pos)
 struct track *track;
 int pos;
 {
 int i;
 struct run *thisrun;

  for (i = 0; i < track->numruns; i++) {
    thisrun = &track->runs[i];
    if ((pos != 0) && ((pos == thisrun->start) || (pos == thisrun->stop)))
      return(1);
  }

  return(0);
}  

#ifdef notdef
o_siginit(seconds) 
int seconds;
{
struct sigvec vec1,vec2,dummy;
extern int o_handlalrm();
extern int o_handlint();
struct itimerval val, oval;

  vec1.sv_handler = o_handlalrm;
  vec1.sv_mask = SIGALRM;
  vec1.sv_flags = 0;

  sigvec(SIGALRM,&vec1,&dummy);

  vec2.sv_handler = o_handlint;
  vec2.sv_mask = SIGINT;
  vec2.sv_flags = 0;

  sigvec(SIGINT,&vec2,&dummy);

  if (seconds > 0) {
    val.it_interval.tv_sec = seconds;
    val.it_interval.tv_usec = 0;
    val.it_value.tv_sec = seconds;
    val.it_value.tv_usec = 0;
  }
  else {
    val.it_interval.tv_sec = 0;
    val.it_interval.tv_usec = 0;
    val.it_value.tv_sec = 0;
    val.it_value.tv_usec = 0;
  }

  setitimer(ITIMER_REAL,&val,&oval);
  return;
}

o_handlalrm()
{
  o_output(Chan,BestP);
  exit(2);
}

o_handlint()
{
  o_output(Chan,BestP);
#ifdef CURSES
#ifdef OUTPUT
  o_output(Chan,BestP);
  exit(2);
#endif
#endif

  return;
}

#endif 
